zipios::FileCollection Class Referenceabstract

FileCollection is an abstract baseclass that represents a collection of files. More...

`#include <fcoll.h>`

Inheritance diagram for zipios::FileCollection:
[legend]

## Public Types

enum | MatchPath { IGNORE , MATCH }

## Public Member Functions

| FileCollection ()
| FileCollection constructor.
| FileCollection (const FileCollection &src)
| Copy constructor.
const FileCollection & | operator= (const FileCollection &src)
| Copy assignment operator.
virtual void | close ()=0
| Closes the FileCollection.
virtual ConstEntries | entries () const
| Returns a vector of const pointers to the entries in the FileCollection.
virtual ConstEntryPointer | getEntry (const string &name, MatchPath matchpath=MATCH) const
| Returns a ConstEntryPointer to a FileEntry object for the entry with the specified name.
virtual istream * | getInputStream (const ConstEntryPointer &entry)=0
| Returns a pointer to an opened istream for the specified FileEntry.
virtual istream * | getInputStream (const string &entry_name, MatchPath matchpath=MATCH)=0
| Returns a pointer to an opened istream for the specified entry name.
virtual string | getName () const
| Returns the name of the FileCollection.
virtual int | size () const
| Returns the number of entries in the FileCollection.
bool | isValid () const
| The member function returns true if the collection is valid.
virtual FileCollection * | clone () const =0
| Create a heap allocated clone of the object this method is called for.
virtual | ~FileCollection ()
| FileCollection destructor.

## Protected Attributes

string | _filename
Entries | _entries
bool | _valid

## Detailed Description

FileCollection is an abstract baseclass that represents a collection of files.

The specializations of FileCollection represents different origins of file collections, such as directories, simple filename lists and compressed archives.

Definition at line 21 of file fcoll.h.

## Member Enumeration Documentation

## MatchPath

enum zipios::FileCollection::MatchPath

Definition at line 46 of file fcoll.h.

## Constructor & Destructor Documentation

## FileCollection() [1/2]

zipios::FileCollection::FileCollection | ( |  | ) |

inline explicit

FileCollection constructor.

Definition at line 24 of file fcoll.h.

## FileCollection() [2/2]

zipios::FileCollection::FileCollection | ( | const FileCollection & | src | ) |

inline

Copy constructor.

Definition at line 115 of file fcoll.h.

## ~FileCollection()

zipios::FileCollection::~FileCollection | ( |  | ) |

virtual

FileCollection destructor.

Definition at line 63 of file fcoll.cpp.

## Member Function Documentation

## clone()

virtual FileCollection * zipios::FileCollection::clone | ( |  | ) | const

pure virtual

Create a heap allocated clone of the object this method is called for.

The caller is responsible for deallocating the clone when he is done with it.

Returns
  A heap allocated copy of the object this method is called for.

Implemented in zipios::CollectionCollection, zipios::DirectoryCollection, and zipios::ZipFile.

## close()

virtual void zipios::FileCollection::close | ( |  | ) |

pure virtual

Closes the FileCollection.

Implemented in zipios::CollectionCollection, zipios::DirectoryCollection, and zipios::ZipFile.

## entries()

ConstEntries zipios::FileCollection::entries | ( |  | ) | const

virtual

Returns a vector of const pointers to the entries in the FileCollection.

Returns
  a ConstEntries containing the entries of the FileCollection.

Exceptions

  InvalidStateException | Thrown if the collection is invalid.

Reimplemented in zipios::CollectionCollection, and zipios::DirectoryCollection.

Definition at line 17 of file fcoll.cpp.

## getEntry()

ConstEntryPointer zipios::FileCollection::getEntry | ( | const string & | name,
|  | MatchPath | matchpath = MATCH ) const

virtual

Returns a ConstEntryPointer to a FileEntry object for the entry with the specified name.

To ignore the path part of the filename in search of a match, specify FileCollection::IGNORE as the second argument.

Parameters

  name | A string containing the name of the entry to get.
  matchpath | Speficy MATCH, if the path should match as well, specify IGNORE, if the path should be ignored.

Returns
  A ConstEntryPointer to the found entry. The returned pointer equals zero if no entry is found.

Exceptions

  InvalidStateException | Thrown if the collection is invalid.

Reimplemented in zipios::CollectionCollection, and zipios::DirectoryCollection.

Definition at line 34 of file fcoll.cpp.

## getInputStream() [1/2]

virtual istream * zipios::FileCollection::getInputStream | ( | const ConstEntryPointer & | entry | ) |

pure virtual

Returns a pointer to an opened istream for the specified FileEntry.

It is the callers responsibility to delete the stream when he is done with it. Returns 0, if there is no such FileEntry in the FileCollection.

Parameters

  entry | A ConstEntryPointer to the FileEntry to get an istream to.

Returns
  an open istream for the specified entry. The istream is allocated on heap and it is the users responsibility to delete it when he is done with it.

Exceptions

  InvalidStateException | Thrown if the collection is invalid.

Implemented in zipios::CollectionCollection, zipios::DirectoryCollection, and zipios::ZipFile.

## getInputStream() [2/2]

virtual istream * zipios::FileCollection::getInputStream | ( | const string & | entry_name,
|  | MatchPath | matchpath = MATCH )

pure virtual

Returns a pointer to an opened istream for the specified entry name.

It is the callers responsibility to delete the stream when he is done with it. Returns 0, if there is no entry with the specified name in the FileCollection.

Parameters

  matchpath | Speficy MATCH, if the path should match as well, specify IGNORE, if the path should be ignored.

Returns
  an open istream for the specified entry. The istream is allocated on heap and it is the users responsibility to delete it when he is done with it.

Exceptions

  InvalidStateException | Thrown if the collection is invalid.

Implemented in zipios::CollectionCollection, zipios::DirectoryCollection, and zipios::ZipFile.

## getName()

string zipios::FileCollection::getName | ( |  | ) | const

virtual

Returns the name of the FileCollection.

Returns
  the name of the FileCollection.

Exceptions

  InvalidStateException | Thrown if the collection is invalid.

Definition at line 50 of file fcoll.cpp.

## isValid()

bool zipios::FileCollection::isValid | ( |  | ) | const

inline

The member function returns true if the collection is valid.

Returns
  true if the collection is valid.

Definition at line 93 of file fcoll.h.

## operator=()

const FileCollection & zipios::FileCollection::operator= | ( | const FileCollection & | src | ) |

inline

Copy assignment operator.

Definition at line 125 of file fcoll.h.

## size()

int zipios::FileCollection::size | ( |  | ) | const

virtual

Returns the number of entries in the FileCollection.

Returns
  the number of entries in the FileCollection.

Exceptions

  InvalidStateException | Thrown if the collection is invalid.

Reimplemented in zipios::CollectionCollection, and zipios::DirectoryCollection.

Definition at line 57 of file fcoll.cpp.

## Member Data Documentation

## _entries

Entries zipios::FileCollection::_entries

protected

Definition at line 106 of file fcoll.h.

## _filename

string zipios::FileCollection::_filename

protected

Definition at line 105 of file fcoll.h.

## _valid

bool zipios::FileCollection::_valid

protected

Definition at line 107 of file fcoll.h.

The documentation for this class was generated from the following files:

- fcoll.h
- fcoll.cpp